package 
{
	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.geom.Rectangle;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.ui.Keyboard;
	
	/**
	 * ...
	 * @author Chris
	 */
	public class Main extends Sprite 
	{
		public var data:XML;
		
		public var images:Array;
		public var blocks:Array;
		public var loaded_images:int;
		public var hero:Bitmap;
		public var hero_speed:Number;
		
		public var level_loaded:Boolean;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			images = new Array();
			blocks = new Array();
			loaded_images = 0;
			level_loaded = false;
			hero_speed = 1;
			
			var loader:URLLoader = new URLLoader(new URLRequest("data.xml"));
			loader.addEventListener(Event.COMPLETE, DataLoaded);
			addEventListener(Event.ENTER_FRAME, RunGame);
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, MoveHero);
			//loader.load();
		}
		public function DataLoaded(e:Event):void
		{
			data = new XML(e.target.data);
			trace("loaded data");
			
			LoadImages();
			//CreateLevel(0);
		}
		public function LoadImages():void
		{
			//check if all images loaded, and create level if it is
			if (loaded_images == data.entities.children().length())
			{
				trace("loading complete, images.length = " + images.length);
				CreateLevel(0);
				return;
			}
			
			var loader:Loader = new Loader()
			loader.load(new URLRequest(data.entities.children()[loaded_images].filename));
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, StoreImage);
		}
		public function StoreImage(e:Event):void
		{
			var bitmap:Bitmap = Bitmap(e.target.content);
			images.push( { name:data.entities.children()[loaded_images].@name, image:bitmap.bitmapData } );
			loaded_images++;
			LoadImages();
		}
		public function CreateLevel(level:int):void
		{
			this.graphics.clear();
			
			for (var i:String in data.levels.children()[level].shapes.children())
			{
				var shape:XML = data.levels.children()[level].shapes.children()[i];

				if (shape.@type == "circle")
				{
					this.graphics.beginFill(shape.color);
					this.graphics.drawCircle(shape.@x, shape.@y, shape.radius);
					this.graphics.endFill();
				}
				else if (shape.@type == "rectangle")
				{
					this.graphics.beginFill(shape.color);
					this.graphics.drawRect(shape.@x, shape.@y, shape.width, shape.height);
					this.graphics.endFill();
					if (shape.is_ground == "true")
						blocks.push(new Rectangle(shape.@x, shape.@y, shape.width, shape.height));
				}
			}
			
			for (var j:String in data.entities.children())
			{
				var entity:XML = data.entities.children()[j];
				if (entity.@name == "bobby")
				{
					hero_speed = Number(entity.speed);
					for (var k:String in images)
						if (images[k].name == "bobby")
						{
							hero = new Bitmap(images[k].image);
							this.addChild(hero);
							
						}
				}
			}
			level_loaded = true;
			hero.x = data.levels.children()[level].starting_point.@x;
			hero.y = data.levels.children()[level].starting_point.@y;
		}
		public function RunGame(e:Event):void
		{
			if (!level_loaded)
				return;
				
			var hero_on_ground:Boolean = false;
			for (var i:String in blocks)
			{
				if (hero.y + hero.height > blocks[i].y && hero.x > blocks[i].x && hero.x + hero.width < blocks[i].x + blocks[i].width)
				{
					hero.y = blocks[i].y - hero.height+1;
					hero_on_ground = true;
				}
			}
			
			if (!hero_on_ground)
				hero.y+=10;
		}
		public function MoveHero(e:KeyboardEvent):void
		{
			if (hero == null)
				return;
			if (e.keyCode == Keyboard.LEFT)
				hero.x -= hero_speed;
			else if(e.keyCode == Keyboard.RIGHT)
				hero.x += hero_speed;
				
			if (hero.y < 0)
				hero.y = 0;
			if (hero.x + hero.width > 800)
				hero.x = 800 - hero.width;
			
		}
		
	}
	
}